/*---------------------------------------------
		
	Inline Math library : Constants implementation (cpp)
	(imath , im_)

	* See Header file for more information

	By Matt Barnett
		(see References)

---------------------------------------------*/

#include "imath.h"

//---- float constants --------
//----------------------------- 

//data ranges (according to msvc help)
//a 4 byte float can hold 7 digits
//an 8 byte double can hold 15 digits
//a long double (10 bytes) can hold 19 digits

//hence all constants match the precision
//of the the type that stores them

const float cnf_epsilon(0.0001f);			//"small" value (considered 0)

//pi constants
//precalced often used pi values

//theroy (radians)
//
//  half_pi radians = 90 degrees
//  pi radians      = 180 degrees
//  two_pi radians  = 360 degeres

const float			 pi(3.141592f);			//(* See ref 1)
const float		half_pi(1.570796f);			//(* See ref 1)
const float		 two_pi(6.283185f);			//(* See ref 1)
const float _pi_over_180(0.0174532f);
const float _180_over_pi(57.295779f);

//---------------------------- 
//----------------------------



//------ ivector3 constants -----
//-------------------------------

extern const ivector3 xaxis(1.0,0.0,0.0);
extern const ivector3 yaxis(0.0,1.0,0.0);
extern const ivector3 zaxis(0.0,0.0,1.0);
extern const ivector3 zero (0.0,0.0,0.0);

//a few colors
extern const ivector3 red  (1.0,0.0,0.0);  
extern const ivector3 green(0.0,1.0,0.0);
extern const ivector3 blue (0.0,0.0,1.0);
extern const ivector3 black(0.0,0.0,0.0);

extern const ivector3 cyan   (0.0,1.0,1.0);
extern const ivector3 magenta(1.0,0.0,1.0);
extern const ivector3 yellow (1.0,1.0,0.0);

//----------------------------
//----------------------------



//-- lookup table constants --
//----------------------------

const float_lookuptable	sintable(5000,0,two_pi,&sinf);
const float_lookuptable	costable(5000,0,two_pi,&cosf);
const float_lookuptable	tantable(5000,0,two_pi,&tanf);

//----------------------------
//----------------------------
